'************************************************
' File:   PrnDir.vbs (WSH 2.0-Beispiel in VBScript) 
' Autor:  Gnter Born www.borncity.de
'
' Erstellt mittels des MS-DOS-Befehls DIR ein Abbild
' des aktuellen Verzeichnisses, ersetzt die Umlaute
' mit der Windows-Kodierung und druckt das Ergebnis
' mittels Notepad.exe auf dem Standarddrucker.
'************************************************
Option Explicit

Const tmpFolder = 2            ' Temp-Ordner des Systems
Const ForWriting = 2           ' E/A-Modus: schreiben

Dim oShell, fso, path, File1, File2 
Dim oFileIn, oFileOut         ' Text-Streams
Dim Args, Ordner, Text

' Prfe, ob Ordner als Argument bergeben wurde
Set Args = WScript.Arguments   ' bergebene Argumente
If Args.Count=0 Then
 MsgBox "Kein Ordnername bergeben!", vbOKOnly + vbCritical, _
        "Verzeichnis drucken"
 WScript.Quit 2
End If

Ordner = """" & Args(0) & """" ' hole Ordnernamen

' FileSystemObject-Objekt erzeugen
Set fso = CreateObject("Scripting.FileSystemObject")

' hole Pfad zum Spezialordner
path = fso.GetSpecialFolder(tmpFolder) 

' Temporre Dateinamen anfordern
File1 = path & fso.GetTempName  
File2 = path & "\Verzeichnis_drucken.txt"

' Erzeuge Shell-Objekt ...
Set oShell = CreateObject("WScript.Shell")
' ... und starte MS-DOS DIR-Kommando mit Ausgabeumleitung 
'     in die temporre Datei. Der 2. Parameter versteckt das
'     Fenster der Eingabeaufforderung, der 3. Parameter bewirkt,
'     dass das Skript auf das Ende des Aufrufs wartet.
oShell.Run "%comspec% /c dir /og /on " & Ordner & " >" & File1, 0, true

' DOS-Befehl ist fertig, die Ergebnisdatei liegt vor.
' Konvertiere deren Inhalt in den Windows-Zeichensatz
If Not (fso.FileExists(File1)) Then  ' Datei vorhanden?
 MsgBox "Temporre Ausgabedatei " & File1 & " nicht gefunden", _
        vbOKOnly + vbCritical, "Verzeichnis drucken"
 WScript.Quit 2
End if

' ffne Eingabedatei und Ausgabedatei
Set oFileIn = fso.OpenTextFile(File1)     ' Eingabedatei
Set oFileOut = fso.OpenTextFile(File2, _
                 ForWriting, true)        ' Ausgabedatei
Text = "Borns Verzeichnisausgabe Version 1.0 " & _
       "- Druckdatum: " & Date() & vbCrLf & vbCrLf

oFileOut.WriteLine (Text)               ' Schreibe Kopfzeile

Do While Not (oFileIn.atEndOfStream)
 Text = oFileIn.Readline                  ' Lese Zeile
' Filtern der Sonderzeichen (MS-DOS in ANSI oder UNICODE)
 Text = Replace(Text, Chr(148), Chr(246))
 Text = Replace(Text, Chr(132), Chr(228))
 Text = Replace(Text, Chr(129), Chr(252))
 Text = Replace(Text, Chr(153), Chr(214))
 Text = Replace(Text, Chr(142), Chr(196))
 Text = Replace(Text, Chr(154), Chr(220))
 Text = Replace(Text, Chr(225), Chr(223))
 oFileOut.WriteLine (Text)               ' Schreibe Textzeile
Loop

' Jetzt Textdatei in Editor laden und drucken - 
' Editorfenster dabei versteckt lassen
oShell.Run "Notepad.exe /p " & File2, 0, true

oFileIn.Close                         ' Dateien schlieen...
oFileOut.Close

fso.DeleteFile File1                  ' und lschen
fso.DeleteFile File2
' Ende